﻿/* ***********************************************************************
This class was created for an ActionScript 3 Tutorial
by Barbara Kaskosz at:

www.flashandmath.com

The class uses ideas from other tutorials on the site by
Doug Ensley and Barbara Kaskosz.

Last modified: May 1, 2008
************************************************************************ */

package bkde.as3.boards {
	
    import flash.display.*;
  
    import flash.events.*;
	
	import flash.net.*;

  public class ParamGallery extends EventDispatcher {
	  
	public static const DATA_LOADED:String = "dataLoaded";
		  
    public static const LOAD_ERROR:String = "loadError";
	
	protected var bIsReady:Boolean;
	
	protected var aFunc1:Array;

    protected var aFunc2:Array;

    protected var aXmin:Array;

    protected var aXmax:Array;

    protected var aYmin:Array;

    protected var aYmax:Array;

    protected var aTmin:Array;

    protected var aTmax:Array;

    protected var aAmin:Array;

    protected var aAmax:Array;

    protected var aBmin:Array;

    protected var aBmax:Array;

    protected var _examplesTotal:int;

    protected var xmlString:URLRequest;

    protected var xmlLoader:URLLoader;
	
	protected var bLoadCanRun:Boolean;

		
	
	public function ParamGallery(){
		
		bLoadCanRun=true;
		
	}
	
	public function loadExamples(str:String):void {
		
		 if(bLoadCanRun){
			   
			bLoadCanRun=false;
		
		xmlString= new URLRequest(str);

        xmlLoader= new URLLoader();

		xmlLoader.addEventListener(Event.COMPLETE, initData);
		
		xmlLoader.addEventListener(IOErrorEvent.IO_ERROR, errorOccurred);

        xmlLoader.load(xmlString);
		
		
		 }
	}
	
	protected function initData(e:Event):void {
		
		var i:int;
		
		var plotDataXML:XML = new XML(xmlLoader.data);
	
	    _examplesTotal= plotDataXML.plot.length();
	
	    aFunc1 = new Array(_examplesTotal);
	    aFunc2 = new Array(_examplesTotal);
	    aXmin = new Array(_examplesTotal);
	    aXmax = new Array(_examplesTotal);
	    aYmin = new Array(_examplesTotal);
	    aYmax = new Array(_examplesTotal);
	    aTmin = new Array(_examplesTotal);
	    aTmax = new Array(_examplesTotal);
	    aAmin = new Array(_examplesTotal);
	    aAmax = new Array(_examplesTotal);
	    aBmin = new Array(_examplesTotal);
	    aBmax = new Array(_examplesTotal);
	
	
	for (i=0; i < _examplesTotal; i++) {
		
		aFunc1[i] = plotDataXML.plot[i].@func1.toString();
		aFunc2[i] = plotDataXML.plot[i].@func2.toString();

		aTmin[i] = plotDataXML.plot[i].tRange.@min.toString();
		aTmax[i] = plotDataXML.plot[i].tRange.@max.toString();
		
		aXmin[i] = plotDataXML.plot[i].xRange.@min.toString();
		aXmax[i] = plotDataXML.plot[i].xRange.@max.toString();
		
		aYmin[i] = plotDataXML.plot[i].yRange.@min.toString();
		aYmax[i] = plotDataXML.plot[i].yRange.@max.toString();
		
		aAmin[i] = plotDataXML.plot[i].aRange.@min.toString();
		aAmax[i] = plotDataXML.plot[i].aRange.@max.toString();
		
		aBmin[i] = plotDataXML.plot[i].bRange.@min.toString();
		aBmax[i] = plotDataXML.plot[i].bRange.@max.toString();
	}
	
		xmlLoader.removeEventListener(Event.COMPLETE, initData);
		
		xmlLoader.removeEventListener(IOErrorEvent.IO_ERROR, errorOccurred);
		
		xmlLoader=null;
		
		xmlString=null;
		
		bLoadCanRun=true;
		
		dispatchEvent(new Event(ParamGallery.DATA_LOADED));
		
	}
	
	protected function errorOccurred(e:Event):void {
		
		xmlLoader.removeEventListener(Event.COMPLETE, initData);
		
		xmlLoader.removeEventListener(IOErrorEvent.IO_ERROR, errorOccurred);
		
		dispatchEvent(new Event(ParamGallery.LOAD_ERROR));
	}
	
	
	public function getExample(n:int):Array {
		
			return [aFunc1[n],aFunc2[n],aXmin[n],aXmax[n],aYmin[n],aYmax[n],aTmin[n],aTmax[n],aAmin[n],aAmax[n],aBmin[n],aBmax[n]];
			
	}
	
	public function get examplesTotal():int {
		
		return _examplesTotal;
		
	}
		
	
}

}

